<template>
  <q-page class="bg-blue-grey-1">
    <dialog-video
      :show-dialog="showDialog"
      :url="url"
      @hide="showDialog = false"
    />

    <q-card
      v-if="categories.length"
      class="bg-blue-grey-1"
      flat
    >
      <q-card-section horizontal>
        <q-scroll-area
          style="min-height: calc(100vh - 70px)"
          class="col-xl-3 col-lg-3 col-md-4"
        >
          <q-card-section class="row content-start">
            <card-category
              v-for="item in categories"
              :key="item.id"
              class="col-12"
              :item="item"
              @category="reload"
            />
          </q-card-section>
        </q-scroll-area>

        <q-separator vertical />

        <q-scroll-area
          style="min-height: calc(100vh - 70px)"
          class="col"
        >
          <q-card-section class="row content-start">
            <card-video
              v-for="item in videos"
              :key="item.id"
              class="col-4"
              :item="item"
              @url="view"
            />
          </q-card-section>
        </q-scroll-area>
      </q-card-section>
    </q-card>

    <q-icon
      v-else
      class="fixed-center"
      name="far fa-folder-open"
      color="blue-grey-2"
      size="300px"
    />
  </q-page>
</template>

<script>
import CardCategory from '../../components/lessons/card-category'
import CardVideo from '../../components/lessons/card-video'
import DialogVideo from '../../components/lessons/dialog-video'

export default {
  name: 'PageVideos',
  components: {
    CardCategory,
    CardVideo,
    DialogVideo
  },
  asyncData: {
    categoriesDefault: [],
    async categories () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/Categories',
          params: {
            filter: {
              where: {
                type: 'video',
                isEnable: true
              }
            }
          }
        }

        const Response = await this.$axios(axiosConfig).then(R => R.data)

        if (Response.length) {
          this.categoryId = Response[0].id
        }

        return Response
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
      }

      return undefined
    },
    videosDefault: [],
    async videos () {
      if (!this.categories.length || !this.categoryId) {
        return undefined
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/VideoLessons',
          params: {
            filter: {
              where: {
                categoryId: this.categoryId,
                isEnable: true
              }
            }
          }
        }

        return this.$axios(axiosConfig)
          .then(R => R.data)
          .finally(() => this.$q.loading.hide())
      } catch (err) {
        this.axiosCatch(err)
      }

      return undefined
    }
  },
  data () {
    return {
      url: '',
      categoryId: null,
      showDialog: false
    }
  },
  watch: {
    categories (categories) {
      if (categories.length) {
        this.asyncReload('videos')
      }
    }
  },
  methods: {
    reload (categoryId) {
      this.categoryId = categoryId
      this.asyncReload('videos')
    },
    view (url) {
      this.url = url
      this.showDialog = true
    }
  }
}
</script>
